##################################################
# Recipe 1.1 
##################################################

library(readxl)
mydata <- read_excel("c:/temp/data.xlsx", sheet="Sheet11")
head(mydata)

mydata <- read.csv("c:/temp/Sheet11.csv")
head(mydata)

mydata <- data.frame( day=1:30, shortrib=c(35, 35, 40, 52, 43, 43, 38, 42, 41, 47, 46, 36, 36, 39, 47, 42, 43, 38, 49, 39, 36, 42, 38, 36, 38, 36, 28, 38, 42, 35) )
head(mydata)

summary(mydata)
summary(mydata$shortrib)



##################################################
# Recipe 1.2
##################################################

library(readxl)
mydata <- read_excel("c:/temp/data.xlsx", sheet="Sheet11")
head(mydata)

library(ggplot2)

ggplot(mydata, aes(x=shortrib)) +
  geom_histogram()

mybk <- function(x, min, max) seq(min, max, length.out=(nclass.Sturges(x)+1))
# mybk <- function(x, min, max) seq(min, max, length.out=(nclass.scott(x)+1)) # Scott ̕@
# mybk <- function(x, min, max) seq(min, max, length.out=(nclass.FD(x)+1))    # Freedman-Diaconis ̕@
( BK <- mybk(mydata$shortrib, 25, 55) )
ggplot(mydata, aes(x=shortrib)) +
  geom_histogram(breaks=BK)

ggplot(mydata, aes(x=shortrib)) +
  geom_histogram(binwidth=5)

ggplot(mydata, aes(x=shortrib)) +
  geom_histogram()

ggplot(mydata, aes(x=shortrib)) +
  geom_histogram(breaks=BK, color="black", fill="cyan") +
  xlab("") + ylab("px") + ggtitle("qXgO")

ggplot(mydata, aes(x=shortrib)) +
  geom_histogram(breaks=BK, color="black", fill="cyan") +
  theme(title=element_blank())

length(mydata$shortrib) # ϐshortrib̃f[^
nrow(mydata)            # f[^t[mydata̍s
1+log2(30)
table( cut(mydata$shortrib, breaks=BK) )



##################################################
# Recipe 1.3
##################################################

mydata <- read.csv("c:/temp/Sheet11.csv")
head(mydata)

library(ggplot2)
ggplot(mydata, aes(x=shortrib)) +
  geom_density()

ggplot(mydata, aes(x=shortrib)) +
  geom_density(color="black", lty=1, lwd=2, adjust=1)

ggplot(mydata, aes(x=shortrib)) +
  geom_density(color="black", lty=1, lwd=2, adjust=1) +
  scale_y_continuous(limits=c(0,0.1)) +
  scale_x_continuous(limits=c(20,60), breaks=c(30,40,50), labels=c("30M","40M","50M"))

ggplot(mydata, aes(x=shortrib)) +
  geom_density(color="black", lty=1, lwd=2, bw="sj") +
  scale_y_continuous(limits=c(0,0.1)) +
  scale_x_continuous(limits=c(20,60), breaks=c(30,40,50), labels=c("30M","40M","50M"))



##################################################
# Recipe 1.4
##################################################

mydata <- data.frame( day=1:30, shortrib=c(35, 35, 40, 52, 43, 43, 38, 42, 41, 47, 46, 36, 36, 39, 47, 42, 43, 38, 49, 39, 36, 42, 38, 36, 38, 36, 28, 38, 42, 35) )
head(mydata)

var(mydata$shortrib)
sd(mydata$shortrib)
round(sd(mydata$shortrib), 2)
t.test(mydata$shortrib, conf.level=0.95)



##################################################
# Recipe 1.5
##################################################

mysimulation <- function(order, mean=40, sd=5, times=20000, seed=123456790, plot=T) {
  day      <- 1:times
  shortrib <- c()
  outstock <- c()
  profit   <- c()
  mymean   <- 0

  myround <- function(x, n=0) {
    floor( round(abs(x)*10^(n)+0.5,10) )*sign(x)/10^(n)
  }
  set.seed(seed)
  for (i in day) {
    shortrib <- c( shortrib, myround(rnorm(1, 40, 5)) )
    outstock <- c( outstock, ifelse(shortrib[i]>order, 1, 0) )
    profit   <- c( profit, 850*min(shortrib[i],order)-200*order )
    mymean   <- mymean + min(shortrib[i],order)/times
  }
  result <- data.frame(day=day, shortrib=shortrib, outstock=outstock, profit=profit)
  print( paste("ϒ:", round(mymean, 1), "M"), quote=F)
  print( paste("i؂ꊄ:", round(100*mean(outstock),1), ""), quote=F)
  print( paste("ϗv:",   round(mean(profit), 1), "~"), quote=F)

  if (plot==T) {
    library(ggplot2)
    g <- ggplot(result, aes(x=day, y=shortrib)) +
      geom_line() + geom_hline(yintercept=order, color="red", lwd=2)
    print(g)
  }
  return(result)
}
result <- mysimulation(order= 40, times=100)
result <- mysimulation(order= 40)
result <- mysimulation(order= 50)
result <- mysimulation(order=100)
