##################################################
# Recipe 2.1
##################################################

# @ ̃AP[gŒm܂H
# library(readxl)
# mydata <- read_excel("c:/temp/data.xlsx", sheet="Sheet21")
# mydata


# A ΂Dȃj[͉łH
library(readxl)
mydata2 <- read_excel("c:/temp/data.xlsx", sheet="Sheet22")
mydata2

mydata2 <- read.csv("c:/temp/Sheet22.csv")
mydata2 <- read.csv(file("c:/temp/Sheet22.csv", encoding="shift-jis"))
mydata2

mydata2 <- data.frame(
  meat  =c("^", "Jr", "n~", "[X", "o", "̑"),
  number=c(20, 24, 16, 12, 6, 2) )
mydata2


library(ggplot2)
ggplot(mydata2, aes(x=meat, y=number)) +
  geom_col()

mydata2$meat2 <- factor(mydata2$meat, levels=c("^","Jr","n~","[X","o","̑"))
ggplot(mydata2, aes(x=meat2, y=number)) +
  geom_col()

mydata2$meat3 <- reorder(mydata2$meat, -mydata2$number)
ggplot(mydata2, aes(x=meat3, y=number, fill=meat3)) +
  geom_col(width=0.5, color="white") +
  scale_fill_manual(values=c("red","green","blue","yellow","purple","gray")) +
  guides(fill=F)


mydata2$meat3 <- reorder(mydata2$meat, -mydata2$number)
ggplot(mydata2, aes(x=meat3, y=number)) +
  geom_col() + geom_hline(yintercept=17, color="black", lwd=2) +
  guides(fill=F) + theme(axis.title=element_blank())

ggplot(mydata2[1:2,], aes(x=meat3, y=number)) +
  geom_col() + guides(fill=F) + theme(axis.title=element_blank()) +
  coord_cartesian(ylim=c(19.9,24.1))


ggplot(mydata2, aes(x="", y=number, fill=meat2)) +
  geom_col()

ggplot(mydata2, aes(x="", y=number, fill=meat2)) +
  geom_col(position=position_stack(reverse=T)) + guides(fill=guide_legend(reverse=T)) 



##################################################
# Recipe 2.2
##################################################

mydata2       <- read.csv("c:/temp/Sheet22.csv")
mydata2       <- read.csv(file("c:/temp/Sheet22.csv", encoding="shift-jis"))
mydata2$meat2 <- factor(mydata2$meat, levels=c("^","Jr","n~","[X","o","̑"))
mydata2

mydata2$prop  <- mydata2$number / sum(mydata2$number)
mydata2

mydata2$prop <- mydata2$number / sum(mydata2$number) * 100
mydata2

library(ggplot2)
ggplot(mydata2, aes(x="", y=prop, fill=meat2)) +
  geom_col(width=0.5, color="white") +
  scale_fill_manual(values=c("red","green","blue","yellow","purple","gray"))

ggplot(mydata2, aes(x=prop, y="", fill=meat2)) +
  geom_col(width=0.5, color="white", position=position_stack(reverse=T)) +
  scale_fill_manual(values=c("red","green","blue","yellow","purple","gray")) +
  theme(axis.title=element_blank())

ggplot(mydata2, aes(x="", y=prop, fill=meat2)) +
  geom_col() + coord_polar("y") +
  scale_fill_manual(values=c("red","green","blue","yellow","purple","gray"))

mydata2$meat4 <- factor( mydata2$meat, levels=rev(c("^","Jr","n~","[X","o","̑")) )
ggplot(mydata2, aes(x="", y=prop, fill=meat4)) +
  geom_col() + coord_polar("y") +
  scale_fill_manual(values=rev( c("red","green","blue","yellow","purple","gray") )) +
  guides(fill=guide_legend(reverse=T)) + theme(axis.title=element_blank())



##################################################
# Recipe 2.3
##################################################

# B ē傤ɍėXłH
# library(readxl)
# mydata <- read_excel("c:/temp/data.xlsx", sheet="Sheet23")
# mydata


( x <- 71 )     # u͂v̐l
( n <- 71+9 )   # 񓚎҂̍vl
( x/n*100 )     # u͂v̐l̊ij

one_prop <- function(x, n, p0) {
  p  <- x/n
  CI <- p + qnorm(0.975)*sqrt( (p*(1-p)/n) )*c(-1,1)
  Pr <- 2 * pnorm(abs((p-p0)/sqrt( p0*(1-p0)/n )), lower=F)
  result        <- c( round(100*p,1), round(100*CI,2), ifelse(Pr<0.0001, "<0.0001",as.character(round(Pr,4))) )
  names(result) <- c("(%)", "95%CI()", "95%CI()", "pl")
  print(result, quote=F)
}
one_prop(x=71, n=80, p0=0.8)



##################################################
# Recipe 2.4
##################################################

library(readxl)
mydata3 <- read_excel("c:/temp/data.xlsx", sheet="Sheet24")
mydata3

mydata3 <- read.csv("c:/temp/Sheet24.csv")
mydata3 <- read.csv(file("c:/temp/Sheet24.csv", encoding="shift-jis"))
mydata3

mydata3 <- data.frame(
  shop  =c("傤","傤","Jr","Jr"),
  answer=c("͂","","͂",""),
  number=c(71, 9, 76, 24))
mydata3


N <- aggregate(mydata3$number, list(mydata3$shop), sum)
names(N) <- c("shop", "N")
N

  mydata3_N  <- merge(mydata3, N, by="shop")
( mydata3_NP <- transform(mydata3_N, prop=round(number/N*100, 2)) )

library(ggplot2)
ggplot(mydata3_NP, aes(x=shop, y=prop, fill=answer)) +
  geom_col(width=0.5, color="white")

two_prop <- function(x1, n1, x2, n2) {
  p1 <- x1/n1 ; p2  <- x2/n2 ; diff <- p1-p2 ; n <- n1+n2 ; p <- (x1+x2)/n
  CI <- diff + qnorm(0.975)*sqrt( p1*(1-p1)/n1+p2*(1-p2)/n2 )*c(-1,1)
  Pr <- pchisq( (diff/sqrt( p*(1-p)*n/n1/n2 ))^2, 1, lower=F)
  result <- c( round(100*p1,1), round(100*p2,1), round(100*diff,1), 
    round(100*CI,2), ifelse(Pr<0.0001, "<0.0001",as.character(round(Pr,4))) )
  names(result) <- c("1(%)", "2(%)", "̍(%)", "95%CI()", 
    "95%CI()", "pl")
  print(result, quote=F)
}
two_prop(x1=71, n1=80, x2=76, n2=100)


library(readxl)
mydata4 <- read_excel("c:/temp/data.xlsx", sheet="Sheet25")
mydata4 <- read.csv("c:/temp/Sheet25.csv")
mydata4 <- read.csv(file("c:/temp/Sheet25.csv", encoding="shift-jis"))
head(mydata4)

mydata4$answer <- factor(mydata4$answer, levels=c("͂",""))
( TAB <- xtabs(~ shop + answer, data=mydata4) ) # O[v  wW̏Ŏw
round( 100*prop.table(TAB, 1), 1)



##################################################
# Recipe 2.5
##################################################

library(readxl)
mydata5 <- read_excel("c:/temp/data.xlsx", sheet="Sheet26")
head(mydata5)

mydata5 <- read.csv("c:/temp/Sheet26.csv")
mydata5 <- read.csv(file("c:/temp/Sheet26.csv", encoding="shift-jis"))
head(mydata5)

mydata5 <- data.frame( day=1:30, tongue=c(29, 25, 35, 25, 24, 25, 39, 31, 35, 39, 33, 43, 29, 23, 28, 28, 29, 27, 36, 27, 31, 26, 24, 37, 41, 35, 22, 23, 23, 28) )
head(mydata5)


library(ggplot2)
mybk <- function(x, min, max) seq(min, max, length.out=(nclass.Sturges(x)+1))
( BK <- mybk(mydata5$tongue, 10, 50) )
ggplot(mydata5, aes(x=tongue)) +
  geom_histogram(breaks=BK, color="black", fill="cyan", aes(y=..density..)) +
  geom_density(color="black", lty=1, lwd=2, adjust=1) +
  scale_x_continuous(limits=c(10,50))


summary(mydata5$tongue)
round(sd(mydata5$tongue), 2)


t.test(mydata5$tongue, mu=35, conf.level=0.95)


t.test(c(34,34,34,34.67,35,35,35,35), mu=35, conf.level=0.95)
t.test(c(34,34,34,34.68,35,35,35,35), mu=35, conf.level=0.95)
t.test(c(34,34,34,34.69,35,35,35,35), mu=35, conf.level=0.95)
t.test(c(34,34,34,34.70,35,35,35,35), mu=35, conf.level=0.95)


one_prop(x=71, n=80, p0=0.8)


options(scipen=1)   # w\ɂȂɂȂ閽
7.801e-05
options(scipen=0)   # ݒɖ߂
7.801*10^(-5)



##################################################
# Recipe 2.6
##################################################

mydata <- data.frame( day=1:30, shortrib=c(35, 35, 40, 52, 43, 43, 38, 42, 41, 47, 46, 36, 36, 39, 47, 42, 43, 38, 49, 39, 36, 42, 38, 36, 38, 36, 28, 38, 42, 35) )
mydata5 <- data.frame( day=1:30, tongue=c(29, 25, 35, 25, 24, 25, 39, 31, 35, 39, 33, 43, 29, 23, 28, 28, 29, 27, 36, 27, 31, 26, 24, 37, 41, 35, 22, 23, 23, 28) )

mydata6  <- merge(mydata, mydata5, by="day")
head(mydata6)


summary(mydata6$shortrib)
summary(mydata6$tongue)

IQR(mydata6$shortrib)
IQR(mydata6$tongue)


library(ggplot2)
ggplot(mydata6, aes(x=shortrib)) +
  geom_density(color="red", lty=1, lwd=1) +
  geom_density(color="blue", lty=2, lwd=2, aes(x=tongue)) +
  scale_x_continuous(limits=c(10,60)) +
  xlab("Red line: shortrib ,   Blue line: tongue")


ggplot(mydata6, aes(x=1, y=shortrib)) +
  geom_boxplot() + stat_summary(fun="mean", geom="point", shape=2, size=3) + 
  geom_boxplot(aes(x=2, y=tongue)) +
  stat_summary(fun="mean", geom="point", shape=3, size=3, aes(x=2, y=tongue)) +
  scale_x_continuous(limits=c(0.5,2.5), breaks=1:2, labels=c("shortrib","tongue")) +
  theme(axis.title=element_blank())


t.test(mydata6$shortrib, mydata6$tongue, conf.level=0.95, var=T)
