###################################################
# Recipe 3.1
###################################################

beta_p <- function(n, x, n0=0, x0=0, l=0, u=1) {
 a      <- x0+1 ; b  <- n0-x0+1
 a_     <- x +a ; b_ <- n -x +b ; p <- pbeta(u, a_, b_) - pbeta(l, a_, b_)
 mean   <- a_/(a_+b_) ; mode <- (a_-1)/(a_+b_-2)
 median <- ifelse(a_>1 & b_>1, (a_-1/3)/(a_+b_-2/3), NA)
 var    <- a_*b_/(a_+b_)^2/(a_+b_+1) ; sd <- sqrt(var)
 result   <- round(c(mean, median, mode, sd, p), 3)
 names(result) <- c("ϒl","l","ŕpl","W΍","m")

 library(ggplot2)
 f <- function(y, c, d, lower, upper) ifelse(y >= lower & y <= upper, dbeta(y, c, d), NA)
 b <- ggplot(data.frame(y=c(0,1)), aes(y)) +
  stat_function(fun=f, args=list(c=a_, d=b_, lower=l, upper=u), geom="area", fill="cyan") +
  stat_function(fun=dbeta, args=list(shape1=a, shape2=b), color="black", lty=2) +
  stat_function(fun=dbeta, args=list(shape1=a_, shape2=b_), color="red", lwd=2) +
  theme(axis.title=element_blank())

  print(b)
  return( result ) 
}

beta_p(n=20, x=14, n0=100, x0=90)
beta_p(n= 0, x= 0, n0=100, x0=90)

beta_p(n=20, x=14, n0=  0, x0= 0)
beta_p(n=20, x=14)

beta_p(n= 0, x= 0, n0=10000, x0=9000) # Oz^O
beta_p(n=20, x=14, n0=10000, x0=9000) # 㕪z



###################################################
# Recipe 3.2
###################################################

library(readxl)
mydata7 <- read_excel("c:/temp/data.xlsx", sheet="Sheet31")
mydata7

mydata7 <- read.csv("c:/temp/Sheet31.csv")
mydata7

mydata7 <- data.frame( day=1:5, customer=c(20, 15, 10, 15, 18), shortrib=c(14, 7, 9, 10, 15) )
mydata7


beta_p <- function(n, x, n0=0, x0=0, l=0, u=1) {
 a      <- x0+1 ; b  <- n0-x0+1
 a_     <- x +a ; b_ <- n -x +b ; p <- pbeta(u, a_, b_) - pbeta(l, a_, b_)
 mean   <- a_/(a_+b_) ; mode <- (a_-1)/(a_+b_-2)
 median <- ifelse(a_>1 & b_>1, (a_-1/3)/(a_+b_-2/3), NA)
 var    <- a_*b_/(a_+b_)^2/(a_+b_+1) ; sd <- sqrt(var)
 result   <- round(c(mean, median, mode, sd, p), 3)
 names(result) <- c("ϒl","l","ŕpl","W΍","m")

 library(ggplot2)
 f <- function(y, c, d, lower, upper) ifelse(y >= lower & y <= upper, dbeta(y, c, d), NA)
 b <- ggplot(data.frame(y=c(0,1)), aes(y)) +
  stat_function(fun=f, args=list(c=a_, d=b_, lower=l, upper=u), geom="area", fill="cyan") +
  stat_function(fun=dbeta, args=list(shape1=a, shape2=b), color="black", lty=2) +
  stat_function(fun=dbeta, args=list(shape1=a_, shape2=b_), color="red", lwd=2) +
  theme(axis.title=element_blank())

  print(b)
  return( result ) 
}

apply(mydata7, 2, sum)         # v
apply(mydata7[1:2,], 2, sum)   # 1`2sڂ݂̂̍v

# beta_p(n=20, x=14, n0=100, x0= 90)
beta_p(n=15, x= 7, n0=120, x0=104)
beta_p(n=35, x=21, n0=100, x0= 90)
beta_p(n=78, x=55, n0=100, x0= 90, l=0.8, u=0.9)


beta_p(n=78, x=55, n0=100, x0= 90, l=0.8, u=0.8)


###################################################
# Recipe 3.3
###################################################

mydata <- data.frame( day=1:30, shortrib=c(35, 35, 40, 52, 43, 43, 38, 42, 41, 47, 46, 36, 36, 39, 47, 42, 43, 38, 49, 39, 36, 42, 38, 36, 38, 36, 28, 38, 42, 35) )
head(mydata)

norm_p <- function(x, l=-Inf, u=Inf) {
 mean   <- mean(x) ; n <- length(x) ; v <- n-1 ; S2 <- v*var(x) ; t <- qt(0.975,v)
 lower  <- mean-t*sqrt(S2/(v*n)) ; upper <- mean+t*sqrt(S2/(v*n))
 p      <- pt((u-mean)/sqrt(S2/(v*n)), v) - pt((l-mean)/sqrt(S2/(v*n)), v)
 result <- round(c(mean, lower, upper, p), 3)
 names(result) <- c("ϒl","M","M","m")
 return( result ) 
}
norm_p(mydata$shortrib, l=38.134, u=41.866)


t.test(mydata$shortrib, mu=40)
t.test(mydata$shortrib, mu=39)
t.test(mydata$shortrib, mu=38)

norm_p(mydata$shortrib, l=40)
norm_p(mydata$shortrib, u=38)
norm_p(mydata$shortrib, l=38, u=40)
