##################################################
# Recipe 4.1
##################################################

library(readxl)
mydata8 <- read_excel("c:/temp/data.xlsx", sheet="Sheet41")
head(mydata8)

mydata8 <- read.csv("c:/temp/Sheet41.csv")
head(mydata8)


summary(mydata8)

library(ggplot2)
ggplot(mydata8, aes(temp, drink)) +
  geom_point()

ggplot(mydata8, aes(temp, drink)) +
  geom_point(pch=18, size=5, color="black")

cor(mydata8$drink, mydata8$temp)



##################################################
# Recipe 4.2
##################################################

mydata8 <- read.csv("c:/temp/Sheet41.csv")
head(mydata8)


result <- lm(drink ~ temp, data=mydata8)
summary(result)

library(ggplot2)
ggplot(mydata8, aes(temp, drink)) +
  geom_point(pch=1, size=4) + stat_smooth(method=lm, se=FALSE, color="black", lwd=2)

new <- data.frame(temp=c(20,25,30,35))
predict(result, new)



##################################################
# Recipe 4.3
##################################################

library(readxl)
mydata9 <- read_excel("c:/temp/data.xlsx", sheet="Sheet42")

mydata9 <- read.csv("c:/temp/Sheet42.csv")

mydata9$busyday <- factor(mydata9$busyday)
mydata9$weather <- factor(mydata9$weather)
head(mydata9)


summary(mydata9)

aggregate(mydata9$drink, list(mydata9$busyday), summary)
aggregate(mydata9$drink, list(mydata9$weather), summary)

result <- lm(drink ~ temp + busyday + weather, data=mydata9)
summary(result)

library(car)
Anova(result, Type="II") 


levels(mydata9$busyday)
levels(mydata9$weather)

new <- data.frame(temp=30,busyday=factor(1),weather=factor(3))
predict(result, new)

ggplot(mydata9, aes(busyday, drink)) +
 geom_boxplot() +
 stat_summary(fun="mean", geom="point", shape=2)

ggplot(mydata9, aes(weather, drink)) +
 geom_boxplot() +
 stat_summary(fun="mean", geom="point", shape=2)

ggplot(mydata9, aes(x=drink, color=busyday)) +
  geom_density(aes(linetype=busyday), lwd=2)

ggplot(mydata9, aes(x=drink, color=weather)) +
  geom_density(aes(linetype=weather), lwd=2)

mydata9$maxtemp <- c(28, 30, 32, 31, 34, 33, 27, 29, 30, 31, 30, 33, 28, 27, 37, 30, 35, 29, 29, 28, 29, 34, 31, 34, 30, 30, 26, 31, 30, 30, 27, 33, 25, 28, 28, 28, 31, 28, 25, 25, 28, 27, 31, 30, 35, 30, 27, 26, 32, 28, 32, 33, 28, 36, 28, 31, 25, 26, 27, 35)
cor(mydata9$maxtemp, mydata9$temp)

result <- lm(drink ~ temp + busyday + weather + maxtemp, data=mydata9)
summary(result)
Anova(result, Type="II") 



##################################################
# Recipe 4.4
##################################################

library(readxl)
mydata10 <- read_excel("c:/temp/data.xlsx", sheet="Sheet43")

mydata10 <- read.csv("c:/temp/Sheet43.csv")
mydata10 <- read.csv(file("c:/temp/Sheet43.csv", encoding="shift-jis"))

mydata10$meat   <- factor(mydata10$meat)
mydata10$gender <- factor(mydata10$gender)
mydata10$times  <- ordered(mydata10$times)
head(mydata10)


summary(mydata10)

# table(mydata10$meat)
# table(mydata10$gender)
# table(mydata10$times)

( TAB1 <- xtabs(~ gender + meat, data=mydata10) )
( TAB2 <- xtabs(~ times  + meat, data=mydata10) )

round( 100*prop.table(TAB1, 1), 1)
round( 100*prop.table(TAB2, 1), 1)

aggregate(mydata10$age, list(mydata10$meat), summary)

library(ggplot2)
mybk <- function(x, min, max) seq(min, max, length.out=(nclass.Sturges(x)+1))
( BK <- mybk(mydata10$age, 20, 60) )
ggplot(mydata10, aes(x=age)) +
  geom_histogram(breaks=BK, color="black", fill="cyan", aes(y=..density..)) +
  geom_density(color="black", lty=1, lwd=2, adjust=1) +
  scale_x_continuous(limits=c(15,65))
ggplot(mydata10, aes(x=meat))   + geom_bar()
ggplot(mydata10, aes(x=gender)) + geom_bar()
ggplot(mydata10, aes(x=times))  + geom_bar()

library(rpart)
library(rpart.plot)
result <- rpart(meat ~ gender + age + times, data=mydata10)
rpart.plot(result, type=3, extra=102)

result_p <- predict(result, mydata10, type="class")
table(mydata10$meat, result_p)

result2 <- rpart(meat ~ ., data=mydata10, control=rpart.control(minsplit=10)) # .FmeatȊȎSϐ
rpart.plot(result2, type=3, extra=102)
# result2 <- rpart(meat ~ ., data=mydata10, control=rpart.control(cp=0.01))   # cpF؂̕Gx
# printcp(result)
# plotcp(result)


mydata10$age_cat <- ifelse(mydata10$age < 40, "Young", "Adult")
( TAB3 <- xtabs(~ gender + meat + age_cat, data=mydata10) )
# prop.table(TAB3[,,1], 1)
# prop.table(TAB3[,,2], 1)
