### {I
# install.packages("ggplot2", dep=T)
# install.packages("dplyr",   dep=T)
# install.packages("scales",  dep=T)
library(ggplot2)
library(dplyr)
library(scales)

head(ToothGrowth, n=3)
tail(ToothGrowth, n=3)

base   <- ggplot(ToothGrowth, aes(x=dose, y=len, color=supp))
points <- base + geom_point()
plot(points)
base + geom_point()



### Ot̍쐬̗
# 1
MS <- summarise(group_by(ToothGrowth, dose), m=mean(len), s=sd(len))
MS
base1 <- ggplot(MS, aes(x=dose, y=m))
base1
base1 + geom_line()
out <- base1 + geom_line() + geom_errorbar(aes(ymin=m-s, ymax=m+s))
out
ggsave("c:/temp/out.pdf", plot=out, width=9, height=9, units="in")


# 2
MS2   <- summarise(group_by(ToothGrowth, dose, supp), m=mean(len), s=sd(len))
MS2
base21 <- ggplot(MS2, aes(x=dose, y=m, color=supp))
base21 + geom_line()

base22 <- ggplot(MS2, aes(x=factor(dose), y=m, color=supp))
base22 + geom_line()

base23 <- ggplot(MS2, aes(x=factor(dose), y=m, color=supp, group=supp))
base23 + geom_line()

base24 <- ggplot(MS2, aes(x=dose, y=m, fill=supp))
base24 + geom_area()

base25 <- ggplot(MS2, aes(x=dose, y=m, fill=supp))
base25 + geom_area(position="fill")

ggsave("c:/temp/out.wmf", device="wmf", scale=1, dpi=300)


# 3
ggplot(ToothGrowth, aes(x=dose, y=len, color=supp)) +
  geom_point()
ggplot(ToothGrowth, aes(x=dose, y=len)) +
  geom_point(color="red")
ggplot(ToothGrowth, aes(x=dose, y=len, shape=supp)) +
  geom_point(color="blue", size=2, position=position_dodge(0.1))
ggplot(ToothGrowth, aes(x=dose, y=len, color=supp)) +
  geom_point() + geom_hline(yintercept=15, color="blue") +
  annotate("text", x=1.8, y=7, label="r^2 == 0.80", parse=T, size=5)


# 4
TMP <- filter(ToothGrowth, len>15)
head(TMP, n=3)
TAB <- summarise(group_by(TMP, dose), N=n())
head(TAB, n=3)

ggplot(TMP, aes(x=dose)) +      #  x Ɏw肳ꂽJeS̃f[^𐔂
  geom_bar()
ggplot(TAB, aes(x=dose, y=N)) + # ϐ y Ɏw肳ꂽl̂܂ܕ\
  geom_col()

ggplot(TMP, aes(x=dose)) + geom_bar() +
  geom_text(aes(label=..count..), stat="count", vjust=1.3, color="yellow")
ggplot(TAB, aes(x=dose, y=N)) + geom_col() +
  geom_text(aes(label=N), vjust=-0.2)

TAB2 <- summarise(group_by(TMP, dose, supp), N=n())
ggplot(TAB2, aes(x=dose, y=N, fill=supp)) + geom_col(width=0.1)
ggplot(TAB2, aes(x=dose, y=N, fill=supp)) + geom_col(position="fill")
ggplot(TAB2, aes(x=dose, y=N, fill=supp)) + 
  geom_col(position=position_stack(reverse=T)) +
  guides(fill=guide_legend(reverse=T))


# 5
ggplot(ToothGrowth, aes(x=interaction(supp, dose), y=len, fill=supp)) +
  geom_boxplot()
ggplot(ToothGrowth, aes(x=interaction(supp, dose), y=len)) +
  geom_boxplot(fill="green")
ggplot(ToothGrowth, aes(x=interaction(supp, dose), y=len, fill=supp)) +
  geom_boxplot(color="red", position="dodge")



### X̃Ot쐬
# 1
ggplot(iris, aes(Species, Petal.Length)) +
  geom_boxplot() +
  stat_summary(fun.y="mean", geom="point", shape=2)
ggplot(iris, aes(y=Petal.Length)) +
  geom_boxplot() + facet_wrap( ~ Species, nrow=1, ncol=3)
ggplot(iris, aes(Species, Petal.Length)) +
  geom_boxplot() + coord_flip()


# 2
ggplot(iris, aes(Petal.Length)) +
  geom_histogram()
ggplot(iris, aes(Petal.Length)) +
  geom_histogram(aes(y = ..density..))
ggplot(iris, aes(Petal.Length)) +
  geom_histogram(aes(y = ..density..)) + 
  geom_density(color="blue")

ggplot(iris, aes(Petal.Length, fill=Species)) +
  geom_histogram(alpha=0.4)
ggplot(iris, aes(Petal.Length)) +
  geom_line(stat="density", color="blue") +
  facet_grid(Species ~ .)


# 3
G1 <- ggplot(iris, aes(Sepal.Length, Sepal.Width)) +
  geom_point(aes(color=Species)) +
  stat_ellipse()
G1
G2 <- ggplot(iris, aes(Sepal.Length, Sepal.Width, color=Species)) +
  geom_point() +
  stat_smooth(method=lm, se=FALSE)  # ftHgFformula=y~x
G2

library(grid)
library(gridExtra)
grid.arrange(G1, G2, nrow=2, ncol=1, as.table=TRUE, heights=c(1,1))
LM <- matrix(c(1,NA,2,2), nrow=2, byrow=T)
grid.arrange(G1, G2, layout_matrix=LM, heights=c(1.5,1))


# 4
Oncology <- data.frame(
  id    =c(   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12),
  rrate =c(  80,  50,  40,  20,   5, -10, -10, -15, -30, -50, -60, -95),
  result=c("PD","PD","PD","PD","SD","SD","SD","SD","PR","PR","PR","CR"))
ggplot(Oncology, aes(x=id, y=rrate, fill=result, color=result)) + 
  geom_bar(stat="identity", width=0.7, position=position_dodge(0.1)) + 
  labs(list(title="Waterfall Plot", x=NULL, y="Response Rate (%)")) + 
  theme(axis.line.x=element_blank(), axis.text.x=element_blank(), axis.ticks.x=element_blank()) +
  coord_cartesian(ylim=c(-100,100))


# 5
base <- ggplot(data.frame(x = c(-5, 5)), aes(x))
base + stat_function(fun=dnorm)

f <- function(x) x^3/2 
base <- ggplot(data.frame(x = c(-5, 5)), aes(x))
base + stat_function(fun=f, color="red")

xlimit <- function(x) { y <- dnorm(x); y[x<0 | x>2] <- NA; y }
base <- ggplot(data.frame(x = c(-5, 5)), aes(x))
base + stat_function(fun=xlimit, geom="area", fill="blue", alpha=0.3) +
  stat_function(fun=dnorm)

ggplot(data.frame(x=c(-5,5)), aes(x)) +
  stat_function(fun=dnorm, args=list(mean=0, sd=1))

q <- qnorm(0.975)
mydnorm <- function(x) {
  y <- ifelse(x < -q | x > q, dnorm(x), NA)
  return(y)
}
ggplot(data.frame(x=c(-5,5)), aes(x)) +
  stat_function(fun=mydnorm, geom="area", fill="blue", alpha=0.3) +
  stat_function(fun=  dnorm, args=list(mean=0, sd=1))


# 6
tmp  <- rnorm(1000, 0, 1)
df   <- data.frame(density(tmp)$x, density(tmp)$y) 
df$x <- df$density.tmp..x
df$y <- df$density.tmp..y
ggplot(data=df, aes(x=x, y=y)) +
  geom_ribbon(data=subset(df, x < -1), aes(ymax=y), ymin=0, fill="blue") +
  geom_area(data=subset(df, -1 <= x & x <= 1), fill="red", alpha=.6) +
  geom_area(data=subset(df, x > 1), fill="green", alpha=0.4) +
  scale_y_continuous(limits=c(0,max(df$y)), breaks=NULL) +
  scale_x_continuous(limits=c(-4,4), breaks=c(-3, -1, 0, 1,3)) +
  labs(x="Samples from Normal Distribution", y="Density") +
  theme(legend.position="none")


# QlFwʃOt̍쐬
mylabel=c("setosa"="S", "versicolor"="Ve", "virginica"="Vi")
ggplot(iris, aes(y=Petal.Length)) + coord_flip() +
  geom_boxplot() + facet_wrap( ~ Species, nrow=3, ncol=1, labeller=labeller(Species=mylabel))
ggplot(iris, aes(y=Petal.Length)) +
  geom_boxplot() + facet_wrap( ~ Species, nrow=1, ncol=3, scales="free_y") +
  theme(strip.text=element_text(face="bold", size=rel(1.5)),
        strip.background=element_rect(fill="cyan", color="red"))


# QlF̃Ot쐬
G0 <- ggplot(iris, aes(Petal.Length))
G1 <- G0 + geom_histogram()
G2 <- G0 + geom_density(color="blue")
G3 <- G0 + geom_histogram(aes(y = ..density..)) + geom_density(color="red")

library(gridExtra)
grid.arrange(G1, G2, G3, nrow=3, heights=c(1,1,1))

LM1 <- matrix(c(1,NA,2,3), nrow=2, byrow=T)
grid.arrange(G1, G2, G3, layout_matrix=LM1, heights=c(1.5,1))
LM2 <- matrix(c(1,1,2,3),  nrow=2, byrow=T)
grid.arrange(G1, G2, G3, layout_matrix=LM2, heights=c(1, 1.5))


# QlF\̒ǉ
library(gridExtra)

G  <- ggplot(iris, aes(Petal.Width)) + geom_histogram()
T1 <- tableGrob(iris[1:16,4:5], rows=NULL, cols=c("Data","Species"),
        theme=ttheme_minimal())
grid.arrange(G, T1, nrow=1, widths=c(2,1))

T0 <- tableGrob(data.frame(x="Iris Data"), rows=NULL, cols=NULL,
  theme=ttheme_minimal(base_size=15, base_color="black"))
LM <- matrix(c(1,2,1,3), nrow=2, byrow=T)
grid.arrange(G, T0, T1, layout_matrix=LM, heights=c(1,10))



### Ot̃JX^}CY
( TG <- summarise(group_by(ToothGrowth, supp, dose), m=mean(len), s=sd(len)) )
pd <- position_dodge(.1)
ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(position=pd) + geom_point(position=pd)

ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(aes(linetype=supp), position=pd) + 
  geom_point(aes(shape=supp, fill=supp, size=supp), position=pd) + 
  scale_color_manual(values=c("red","blue")) +
  scale_linetype_manual(values=c("solid", "dashed")) +
  scale_shape_manual(values=c(2,19)) +
  scale_fill_manual(values=c("green","yellow")) +
  scale_size_manual(values=c(5,2)) +
  theme(legend.position=c(0.0,0.8), legend.justification=c(0,0)) +
  xlab("Dose") + ylab("Length") + ggtitle("Mean Plot") + 
  scale_x_continuous(limits=c(0.3,2.2), breaks=c(0.5,1,2), labels=c("0.5mg","1.0mg","2.0mg")) +
  scale_y_continuous(limits=c(0,40), breaks=seq(0,40,20), labels=c("0mm","20mm","40mm"))


# F̎w
barplot(1:8, col=1:8, axes=F)
colors()


# ֐ theme() ɂ^Cg⎲x̕ύX
ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(position=pd) + geom_point(position=pd) +
 #theme(axis.title.x=element_blank()) # x ̃x
  theme(axis.title.x=element_blank(),
    axis.text.x=element_text(angle=30, hjust=1, vjust=1,
    face="italic", colour="red", size=12))


# QlFUf[^̍WEXP[̒
points <- ggplot(ToothGrowth, aes(x=supp, y=len, color=factor(dose))) + geom_point()
points + scale_x_discrete("dose", limits=rev(levels(ToothGrowth$supp)),
  labels=c("VC"="Vitamin C"), breaks="VC")
points + xlim("OJ")


# QlF}̒
points <- ggplot(ToothGrowth, aes(x=supp, y=len, color=factor(dose))) + geom_point()
points + scale_color_discrete(limits=c("1","2","0.5")) + labs(color="Dose")
points + guides(color=guide_legend(reverse=T))


# QlFtf[^̕\ƍWϊ̗
df <- data.frame(date=seq(Sys.Date(), len=50, by="1 day"), y=runif(50))
ggplot(df, aes(date,y)) + geom_line() + scale_x_date(labels=date_format("%Y/%m/%d")) # scales pbP[W

df <- data.frame(x=1:5, y=1:5)
mysqrt_trans <- function() trans_new("mysqrt", 
  function(x) sqrt(x), function(x) x^2) # ϊƋtϊ`
ggplot(df, aes(x=x, y=y)) + geom_point() + coord_trans(x="mysqrt")


# ڂ̕ύX
ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(position=pd) + geom_point(position=pd) + 
  annotate("text", x=1.8, y=8, label="2.0mg", col="green") + 
  annotate("segment", x=2, xend=2, y=10, yend=20, arrow=arrow(), col="green") +   # grid pbP[W
  annotate("pointrange", x=1.5, y=15, ymin=10, ymax=20, colour="green", size=2) +
  theme_classic()



### ֐ theme() ̕⑫
ggplot(ToothGrowth, aes(x=dose, y=len, color=supp)) +
  geom_point() + ggtitle("Sample") + 
  theme(axis.title.x=element_text(size=15, color="red"),
    axis.text.y=element_blank(), axis.ticks.y=element_blank(),
    axis.line=element_line(color="green"),
    plot.title=element_text(size = rel(1.5), face="bold.italic"),
    legend.position=c(0.8, 0.2), legend.title=element_text(color="blue"))



### pFKaplan Meier Plot

## 1
library(survival)
aml$group <- ifelse(aml$x=="Maintained", 1, 2)
result    <- survfit(Surv(time, status) ~ group, data = aml) # survival pbP[W
# summary(result)
# plot(result, col=2:1, xlab="Time", ylab="Survival Rate")
# plot(result, col=2:1, xlab="Time", ylab="Cumulative Incidence", fun="event")

# 1 Q̏ꍇ
df_tmp  <- data.frame(time=result$time, n.risk=result$n.risk, n.event=result$n.event, n.censor = result$n.censor, surv=result$surv)
df_zero <- data.frame(time=0, n.risk=result$n, n.event=0, n.censor=0, surv=1)
df      <- rbind(df_zero, df_tmp)
df$fail <- 1 - df$surv

# 2 Qȏ̏ꍇ
mystrata <- c()
for(i in 1:length(result$strata)) mystrata <- c(mystrata, rep(names(result$strata)[i], result$strata[i]))
df_tmp <- data.frame(time=result$time, n.risk=result$n.risk, n.event=result$n.event, n.censor=result$n.censor, surv=result$surv, strata=factor(mystrata))
df <- NULL
for(i in 1:length(result$strata)) {
  mysubset <- subset(df_tmp, strata==names(result$strata)[i])
  df_zero  <- data.frame(time=0, n.risk=result$n[i], n.event=0, n.censor=0, surv=1, strata=names(result$strata[i]))
  df       <- rbind(df, rbind(df_zero, mysubset))
}
df$fail <- 1 - df$surv

ggplot(data=df) +
  geom_step(mapping=aes(x=time, y=surv, color=strata, linetype=strata), size=1.2) + 
  geom_point(data=subset(df, n.censor>0), mapping=aes(x=time, y=surv, color=strata), shape=3, size=2) +
  xlab("Time") + ylab("Survival Rate") + 
  scale_x_continuous(breaks=seq(0, 160, by=20), limits=c(0, 170)) +
  scale_y_continuous(breaks=seq(0, 1, by=0.2), limits=c(0, 1))


## 2
result2 <- summary(result, time=seq(0,180,20))

# 1 Q̏ꍇ
atrisk_tmp <- data.frame(time=result2$time, n.risk=result2$n.risk)

# 2 Qȏ̏ꍇ
atrisk_tmp      <- data.frame(time=result2$time, n.risk=result2$n.risk, strata=result2$strata)
atrisk1         <- subset(atrisk_tmp, strata=="group=1")
atrisk2         <- subset(atrisk_tmp, strata=="group=2")
atRisk          <- subset(merge(atrisk1, atrisk2, by="time", all=T), select=c(time, n.risk.x, n.risk.y))
atRisk$n.risk.x <- replace(atRisk$n.risk.x, which(is.na(atRisk$n.risk.x)), 0)
atRisk$n.risk.y <- replace(atRisk$n.risk.y, which(is.na(atRisk$n.risk.y)), 0)
names(atRisk)   <- c("Time", "Group=1", "Group=2")

KM <- ggplot(data=df) +
  geom_step(mapping=aes(x=time, y=fail, color=strata, linetype=strata), size=1.2) + 
  geom_point(data=subset(df, n.censor>0), mapping=aes(x=time, y=fail, color=strata), shape=3, size=2) +
  xlab("Time") + ylab("Cumulative Incidence") + 
  scale_x_continuous(breaks=seq(0, 160, by=20), limits=c(0, 170)) +
  scale_y_continuous(breaks=seq(0, 1, by=0.2), limits=c(0, 1))

library(grid)
library(gridExtra)
TB <- tableGrob(t(atRisk), cols=NULL)                       # gridExtra pbP[W
TB$widths <- unit(rep(0.8/ncol(TB), ncol(TB)), "npc")
grid.arrange(KM, TB, nrow=2, as.table=TRUE, heights=c(3,1)) # gridExtra pbP[W


## 3
# install.packages("ggthemes", dep=T)
# install.packages("survminer", dep=T)
library(survminer)
library(ggthemes)

aml$group <- ifelse(aml$x=="Maintained", 1, 2)
result    <- survfit(Surv(time, status) ~ group, data = aml)
ggsurvplot(result, data=aml, risk.table=TRUE,
  ggtheme=theme_bw(), tables.theme=theme_cleantable() +
  theme(panel.grid=element_blank()) )



### pFForest Plot
MCI    <-            summarise(group_by(iris, Species), M=mean(Sepal.Length), S=sd(Sepal.Length))
MCI    <- rbind(MCI, summarise(group_by(iris, Species), M=mean(Sepal.Width ), S=sd(Sepal.Width )))
MCI    <- rbind(MCI, summarise(group_by(iris, Species), M=mean(Petal.Length), S=sd(Petal.Length)))
MCI    <- rbind(MCI, summarise(group_by(iris, Species), M=mean(Petal.Width ), S=sd(Petal.Width )))
MCI$M  <- round(MCI$M, 1)
MCI$L  <- round(MCI$M - MCI$S, 2)
MCI$U  <- round(MCI$M + MCI$S, 2)
MCI$ID <- as.numeric(row.names(MCI))
MCI$GROUP <- factor(MCI$ID, labels=paste("Group",1:12))
MCI

## 1
ggplot(data=MCI, aes(x=M, y=GROUP, xmin=L, xmax=U)) +
  geom_errorbarh() + geom_point() + xlab("Mean +- SD") + ylab("Group") +
  geom_vline(xintercept=3.5, col="red", lty=2) +
  scale_y_discrete("GROUP", limits=rev(levels(MCI$GROUP)))


## 2
library(grid)
library(gridExtra)
FP <- ggplot(data=MCI, aes(x=M, y=ID, xmin=L, xmax=U)) +
  geom_errorbarh() + geom_point() + scale_y_reverse() + ggtitle("Sample Plot") +
  geom_vline(xintercept=3.5, col="red", lty=2) + theme_bw() +
  theme(axis.title.x=element_blank(), panel.grid=element_blank(),
        axis.title.y=element_blank(), axis.text.y=element_blank(),
        axis.line.y=element_blank(), axis.ticks.y=element_blank(),
        plot.margin=margin(0.07, 0.05, 0.01, 0, "npc"))
TB <- tableGrob(MCI[,c(7,2,4,5)], rows=NULL, cols=c("Group","Mean","Lower","Upper"),
        theme=ttheme_minimal())
grid.arrange(TB, FP, nrow=1, as.table=TRUE, widths=c(1,2))


## 3
FP <- ggplot(data=MCI, aes(x=M, y=ID, xmin=L, xmax=U)) +
  geom_errorbarh() + geom_point() + ggtitle("Sample Plot") +
  geom_vline(xintercept=3.5, col="red", lty=2) + theme_bw() +
  theme(axis.title.x=element_blank(), panel.grid=element_blank(),
        axis.title.y=element_blank(), axis.text.y=element_blank(),
        axis.line.y=element_blank(), axis.ticks.y=element_blank(),
        plot.title=element_text(size=15))

TB <- ggplot(data=MCI, aes(y=ID)) + 
    xlab("") + 
    theme(axis.title.y=element_blank(), axis.text=element_blank(),
      axis.line=element_blank(), axis.ticks=element_blank(),
      panel.background=element_blank(), panel.border=element_blank(),
      panel.grid.major=element_blank(), panel.grid.minor=element_blank(),
      legend.position="none", plot.background=element_blank(),
      plot.margin=margin(0.04, 0.01, 0.04, 0.01, "npc"))

TB1 <- TB + geom_text(aes(x=1, label=GROUP)) + ggtitle("Group")
TB2 <- TB + geom_text(aes(x=1, label=M)) + ggtitle("Mean")
TB3 <- TB + geom_text(aes(x=1, label=L)) + ggtitle("Lower")
TB4 <- TB + geom_text(aes(x=1, label=U)) + ggtitle("Upper")

LM <- matrix(c(1,2,2,2,2,3,4,5), nrow=1)
grid.arrange(TB1, FP, TB2, TB3, TB4, layout_matrix=LM)


## 4
FP <- ggplot(data=MCI, aes(x=M, y=ID, xmin=L, xmax=U)) +
  geom_errorbarh() + geom_point() + ggtitle("") + scale_y_reverse() +
  geom_vline(xintercept=3.5, col="red", lty=2) + theme_bw() +
  theme(axis.title.x=element_blank(), panel.grid=element_blank(),
        axis.title.y=element_blank(), axis.text.y=element_blank(),
        axis.line.y=element_blank(), axis.ticks.y=element_blank(),
        plot.title=element_text(size=8))

TB <- ggplot(data=MCI, aes(y=ID)) + 
    xlab("") + 
    theme(axis.title.y=element_blank(), axis.text=element_blank(),
      axis.line=element_blank(), axis.ticks=element_blank(),
      panel.background=element_blank(), panel.border=element_blank(),
      panel.grid.major=element_blank(), panel.grid.minor=element_blank(),
      legend.position="none", plot.background=element_blank(),
      plot.margin=margin(0.04, 0.01, 0.04, 0.01, "npc"))

HD1 <- tableGrob(data.frame(x="Sample Plot"), rows=NULL, cols=NULL,
  theme=ttheme_minimal(base_size=15, base_color="black"))
HD2 <- tableGrob(data.frame(x="95% CI"), rows=NULL, cols=NULL,
  theme=ttheme_minimal(base_size=15, base_color="black"))

TB1 <- TB + geom_text(aes(x=1, label=GROUP)) + ggtitle("Group") + scale_y_reverse()
TB2 <- TB + geom_text(aes(x=1, label=M)) + ggtitle("Mean") + scale_y_reverse()
TB3 <- TB + geom_text(aes(x=1, label=L)) + ggtitle("Lower") + scale_y_reverse()
TB4 <- TB + geom_text(aes(x=1, label=U)) + ggtitle("Upper") + scale_y_reverse()

LM <- matrix(c(1,1,1,1,1,1,2,2,
               3,4,4,4,4,5,6,7), nrow=2, byrow=T)
grid.arrange(HD1,HD2,TB1, FP, TB2, TB3, TB4, layout_matrix=LM, heights=c(1,20))
